<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InvoiceResponse StructType
 * @subpackage Structs
 */
class InvoiceResponse extends AbstractStructBase
{
    /**
     * The InvoiceResponseType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: ns0:InvoiceResponseType
     * @var \StructType\InvoiceResponseType[]
     */
    public $InvoiceResponseType;
    /**
     * Constructor method for InvoiceResponse
     * @uses InvoiceResponse::setInvoiceResponseType()
     * @param \StructType\InvoiceResponseType[] $invoiceResponseType
     */
    public function __construct(array $invoiceResponseType = array())
    {
        $this
            ->setInvoiceResponseType($invoiceResponseType);
    }
    /**
     * Get InvoiceResponseType value
     * @return \StructType\InvoiceResponseType[]|null
     */
    public function getInvoiceResponseType()
    {
        return $this->InvoiceResponseType;
    }
    /**
     * Set InvoiceResponseType value
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceResponseType[] $invoiceResponseType
     * @return \StructType\InvoiceResponse
     */
    public function setInvoiceResponseType(array $invoiceResponseType = array())
    {
        foreach ($invoiceResponseType as $invoiceResponseInvoiceResponseTypeItem) {
            // validation for constraint: itemType
            if (!$invoiceResponseInvoiceResponseTypeItem instanceof \StructType\InvoiceResponseType) {
                throw new \InvalidArgumentException(sprintf('The InvoiceResponseType property can only contain items of \StructType\InvoiceResponseType, "%s" given', is_object($invoiceResponseInvoiceResponseTypeItem) ? get_class($invoiceResponseInvoiceResponseTypeItem) : gettype($invoiceResponseInvoiceResponseTypeItem)), __LINE__);
            }
        }
        $this->InvoiceResponseType = $invoiceResponseType;
        return $this;
    }
    /**
     * Add item to InvoiceResponseType value
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceResponseType $item
     * @return \StructType\InvoiceResponse
     */
    public function addToInvoiceResponseType(\StructType\InvoiceResponseType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InvoiceResponseType) {
            throw new \InvalidArgumentException(sprintf('The InvoiceResponseType property can only contain items of \StructType\InvoiceResponseType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->InvoiceResponseType[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InvoiceResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
